Index: issm/trunk/src/c/parallel/diagnostic_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic_core.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/diagnostic_core.cpp	(revision 465)
@@ -74,6 +74,6 @@
 			
 		if(debug)_printf_("%s\n","computing surface slope (x and y derivatives)...");
-		diagnostic_core_linear(&slopex,fem_sl,inputs,SurfaceSlopeComputeXAnalysisEnum());
-		diagnostic_core_linear(&slopey,fem_sl,inputs,SurfaceSlopeComputeYAnalysisEnum());
+		diagnostic_core_linear(&slopex,fem_sl,inputs,SlopeComputeAnalysisEnum(),SurfaceXAnalysisEnum());
+		diagnostic_core_linear(&slopey,fem_sl,inputs,SlopeComputeAnalysisEnum(),SurfaceYAnalysisEnum());
 
 		if (dim==3){
@@ -89,5 +89,5 @@
 
 		if(debug)_printf_("%s\n"," computing hutter velocities...");
-		diagnostic_core_linear(&ug,fem_dhu,inputs,DiagnosticHutterAnalysisEnum());
+		diagnostic_core_linear(&ug,fem_dhu,inputs,DiagnosticAnalysisEnum(),HutterAnalysisEnum());
 
 		if(debug)_printf_("%s\n"," computing pressure according to MacAyeal...");
@@ -106,5 +106,5 @@
 		
 		if(debug)_printf_("%s\n"," computing horizontal velocities...");
-		diagnostic_core_nonlinear(&ug,NULL,NULL,fem_dh,inputs,DiagnosticHorizAnalysisEnum());
+		diagnostic_core_nonlinear(&ug,NULL,NULL,fem_dh,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
 
 		if(debug)_printf_("%s\n"," computing pressure according to MacAyeal...");
@@ -121,5 +121,5 @@
 		if(debug)_printf_("%s\n"," computing vertical velocities...");
 		inputs->Add("velocity",ug_horiz,numberofdofspernode_dh,numberofnodes);
-		diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticVertAnalysisEnum());
+		diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticAnalysisEnum(),VertAnalysisEnum());
 
 		if(debug)_printf_("%s\n"," combining horizontal and vertical velocities...");
@@ -138,6 +138,6 @@
 
 			if(debug)_printf_("%s\n","computing bed slope (x and y derivatives)...");
-			diagnostic_core_linear(&slopex,fem_sl,inputs,BedSlopeComputeXAnalysisEnum());
-			diagnostic_core_linear(&slopey,fem_sl,inputs,BedSlopeComputeYAnalysisEnum());
+			diagnostic_core_linear(&slopex,fem_sl,inputs,SlopeComputeAnalysisEnum(),BedXAnalysisEnum());
+			diagnostic_core_linear(&slopey,fem_sl,inputs,SlopeComputeAnalysisEnum(),BedYAnalysisEnum());
 			SlopeExtrudex( slopex, fem_sl->elements,fem_sl->nodes,fem_sl->loads,fem_sl->materials);
 			SlopeExtrudex( slopey, fem_sl->elements,fem_sl->nodes,fem_sl->loads,fem_sl->materials);
@@ -160,5 +160,5 @@
 			if(debug)_printf_("%s\n"," computing stokes velocities and pressure ...");
 			VecFree(&ug);
-			diagnostic_core_nonlinear(&ug,NULL,NULL,fem_ds,inputs,DiagnosticStokesAnalysisEnum());
+			diagnostic_core_nonlinear(&ug,NULL,NULL,fem_ds,inputs,DiagnosticAnalysisEnum(),StokesAnalysisEnum());
 		
 			//decondition" pressure
Index: issm/trunk/src/c/parallel/diagnostic_core_linear.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic_core_linear.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/diagnostic_core_linear.cpp	(revision 465)
@@ -11,5 +11,5 @@
 #include "../issm.h"
 
-void diagnostic_core_linear(Vec* pug,FemModel* fem,ParameterInputs* inputs,int analysis_type){
+void diagnostic_core_linear(Vec* pug,FemModel* fem,ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	/*parameters:*/
@@ -41,5 +41,5 @@
 	//*Generate system matrices
 	if (debug) _printf_("   Generating matrices\n");
-	SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,fem->loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type); 
+	SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,fem->loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type,sub_analysis_type); 
 
 	/*!Reduce matrix from g to f size:*/
Index: issm/trunk/src/c/parallel/diagnostic_core_nonlinear.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic_core_nonlinear.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/diagnostic_core_nonlinear.cpp	(revision 465)
@@ -11,5 +11,5 @@
 #include "../issm.h"
 
-void diagnostic_core_nonlinear(Vec* pug,Mat* pKff0,Mat* pKfs0, FemModel* fem,ParameterInputs* inputs,int analysis_type){
+void diagnostic_core_nonlinear(Vec* pug,Mat* pKff0,Mat* pKfs0, FemModel* fem,ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 
@@ -84,9 +84,9 @@
 		if (debug) _printf_("   Generating matrices\n");
 		//*Generate system matrices
-		SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type); 
+		SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type,sub_analysis_type); 
 
 		if (debug) _printf_("   Generating penalty matrices\n");
 		//*Generate penalty system matrices
-		PenaltySystemMatricesx(Kgg, pg,fem->elements,fem->nodes,loads,fem->materials,kflag,pflag,inputs,analysis_type); 
+		PenaltySystemMatricesx(Kgg, pg,fem->elements,fem->nodes,loads,fem->materials,kflag,pflag,inputs,analysis_type,sub_analysis_type); 
 
 		if (debug) _printf_("   reducing matrix from g to f set\n");
@@ -122,5 +122,5 @@
 		inputs->Add("velocity",ug,numberofdofspernode,numberofnodes);
 		
-		PenaltyConstraintsx(&constraints_converged, &num_unstable_constraints, fem->elements,fem->nodes,loads,fem->materials,inputs,analysis_type); 
+		PenaltyConstraintsx(&constraints_converged, &num_unstable_constraints, fem->elements,fem->nodes,loads,fem->materials,inputs,analysis_type,sub_analysis_type); 
 
 		//Figure out if convergence is reached.
@@ -167,5 +167,5 @@
 		kflag=1; pflag=0; //stiffness generation only
 	
-		SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,fem->loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type); 
+		SystemMatricesx(&Kgg, &pg,fem->elements,fem->nodes,fem->loads,fem->materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type,sub_analysis_type); 
 	
 		Reducematrixfromgtofx(&Kff,&Kfs,Kgg,fem->Gmn,fem->nodesets);
Index: issm/trunk/src/c/parallel/objectivefunctionC.cpp
===================================================================
--- issm/trunk/src/c/parallel/objectivefunctionC.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/objectivefunctionC.cpp	(revision 465)
@@ -39,4 +39,5 @@
 	double* p_g_copy=NULL;
 	int     analysis_type;
+	int     sub_analysis_type;
 	Vec     u_g=NULL;
 	double* u_g_double=NULL;
@@ -59,4 +60,5 @@
 	femmodel->parameters->FindParam((void*)&fit,"fit");
 	femmodel->parameters->FindParam((void*)&analysis_type,"analysis_type");
+	femmodel->parameters->FindParam((void*)&sub_analysis_type,"sub_analysis_type");
 	femmodel->parameters->FindParam((void*)&numberofnodes,"numberofnodes");
 
@@ -75,5 +77,5 @@
 
 	//Run diagnostic with updated parameters.
-	diagnostic_core_nonlinear(&u_g,NULL,NULL,femmodel,inputs,analysis_type);
+	diagnostic_core_nonlinear(&u_g,NULL,NULL,femmodel,inputs,analysis_type,sub_analysis_type);
 	VecToMPISerial(&u_g_double,u_g); VecFree(&u_g);
 
@@ -81,5 +83,5 @@
 	inputs->Add("fit",fit[n]);
 	Misfitx( &J, femmodel->elements,femmodel->nodes, femmodel->loads, femmodel->materials, 
-		u_g_double,u_g_obs, inputs,analysis_type);
+		u_g_double,u_g_obs, inputs,analysis_type,sub_analysis_type);
 
 
Index: issm/trunk/src/c/parallel/parallel.h
===================================================================
--- issm/trunk/src/c/parallel/parallel.h	(revision 464)
+++ issm/trunk/src/c/parallel/parallel.h	(revision 465)
@@ -12,6 +12,6 @@
 
 void diagnostic_core(Vec* pug, Vec* ppg,FemModel* fems, ParameterInputs* inputs);
-void diagnostic_core_nonlinear(Vec* pug,Mat* pK_ff0,Mat* pK_fs0, FemModel* fem,ParameterInputs* inputs,int analysis_type);
-void diagnostic_core_linear(Vec* ppg,FemModel* fem,ParameterInputs* inputs,int  analysis_type);
+void diagnostic_core_nonlinear(Vec* pug,Mat* pK_ff0,Mat* pK_fs0, FemModel* fem,ParameterInputs* inputs,int analysis_type,int sub_analysis_type);
+void diagnostic_core_linear(Vec* ppg,FemModel* fem,ParameterInputs* inputs,int  analysis_type,int sub_analysis_type);
 int cielothermal_core(Vec** pt_g,ParameterInputs* inputs,FemModel* femmodel);
 
@@ -29,9 +29,9 @@
 //int ParameterUpdate(double* search_vector,int step, WorkspaceParams* workspaceparams,BatchParams* batchparams);
 void OutputDiagnostic(Vec u_g,Vec p_g, FemModel* femmodels,char* filename);
-int OutputThermal(Vec* t_g,Vec* tpartition,char* filename,char* analysis_type);
+int OutputThermal(Vec* t_g,Vec* tpartition,char* filename,char* analysis_type,int sub_analysis_type);
 void OutputControl(Vec u_g,double* p_g, double* J, int nsteps, Vec partition,char* filename,NodeSets* nodesets);
 void WriteLockFile(char* filename);
 
-void CreateFemModel(FemModel* femmodel,ConstDataHandle MODEL,char* analysis_type);
+void CreateFemModel(FemModel* femmodel,ConstDataHandle MODEL,char* analysis_type,char* sub_analysis_type);
 //int BatchDebug(Mat* Kgg,Vec* pg,FemModel* femmodel,char* filename);
 
Index: issm/trunk/src/c/parallel/thermal.cpp
===================================================================
--- issm/trunk/src/c/parallel/thermal.cpp	(revision 465)
+++ issm/trunk/src/c/parallel/thermal.cpp	(revision 465)
@@ -0,0 +1,102 @@
+/*!\file:  thermal.cpp
+ * \brief: thermal solution
+ */ 
+
+#include "../issm.h"
+#include "./parallel.h"
+
+#undef __FUNCT__ 
+#define __FUNCT__ "thermal"
+
+#ifdef HAVE_CONFIG_H
+	#include "config.h"
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+int main(int argc,char* *argv){
+
+	/*I/O: */
+	FILE* fid=NULL;
+	char* inputfilename=NULL;
+	char* outputfilename=NULL;
+	char* lockname=NULL;
+	int   numberofnodes;
+
+	/*Fem models : */
+	FemModel femmodels[2];
+
+	/*initial velocity and pressure: */
+	Vec u_g=NULL;
+	Vec p_g=NULL;
+
+	
+	/*solution vectors: */
+	Vec t_g=NULL;
+	Vec m_g=NULL;
+
+	ParameterInputs* inputs=NULL;
+	int waitonlock=0;
+	
+	MODULEBOOT();
+
+	#if !defined(_PARALLEL_) || (defined(_PARALLEL_) && !defined(_HAVE_PETSC_))
+	throw ErrorException(__FUNCT__," parallel executable was compiled without support of parallel libraries!");
+	#endif
+
+	PetscInitialize(&argc,&argv,(char *)0,"");  
+
+	/*Size and rank: */
+	MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);  
+	MPI_Comm_size(MPI_COMM_WORLD,&num_procs); 
+
+	_printf_("recover , input file name and output file name:\n");
+	inputfilename=argv[2];
+	outputfilename=argv[3];
+	lockname=argv[4];
+
+	/*Open handle to data on disk: */
+	fid=fopen(inputfilename,"rb");
+	if(fid==NULL) throw ErrorException(__FUNCT__,exprintf("%s%s%s","could not open file ",inputfilename," for binary reading")); 
+
+	_printf_("read and create finite element model:\n");
+	CreateFemModel(&femmodels[0],fid,"thermal","");
+	CreateFemModel(&femmodels[1],fid,"melting","");
+
+	_printf_("initialize inputs:\n");
+	femmodels[0].parameters->FindParam((void*)&u_g,"u_g");
+	femmodels[0].parameters->FindParam((void*)&p_g,"p_g");
+	femmodels[0].parameters->FindParam((void*)&numberofnodes,"numberofnodes");
+
+	inputs=new ParameterInputs;
+	//inputs->Add("velocity",u_g_initial,3,numberofnodes);
+
+	//erase velocities: 
+	//param=(Param*)femmodels[0].parameters->FindParamObject("u_g");
+	//femmodels[0].parameters->DeleteObject((Object*)param);
+
+	_printf_("call computational core:\n");
+	diagnostic_core(&u_g,&p_g,femmodels,inputs);
+
+	_printf_("write results to disk:\n");
+	OutputDiagnostic(u_g,p_g,&femmodels[0],outputfilename);
+
+	_printf_("write lock file:\n");
+	femmodels[0].parameters->FindParam((void*)&waitonlock,"waitonlock");
+	if (waitonlock){
+		WriteLockFile(lockname);
+	}
+		
+	_printf_("closing MPI and Petsc\n");
+	MPI_Barrier(MPI_COMM_WORLD);
+
+	/*Close MPI libraries: */
+	PetscFinalize(); 
+
+
+	/*end module: */
+	MODULEEND();
+	
+	return 0; //unix success return;
+}
+	
Index: issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp
===================================================================
--- issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 465)
+++ issm/trunk/src/c/shared/Dofs/DistributeNumDofs.cpp	(revision 465)
@@ -0,0 +1,47 @@
+/*!\file:  DistributeNumDofs.cpp
+ * \brief: figure out the maximum number of dofs per grid.
+ */ 
+
+#include "../../include/macros.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+#include "../shared.h"
+
+#undef __FUNCT__  
+#define __FUNCT__ "DistributeNumDofs"
+
+int DistributeNumDofs(int *pnumdofs,int analysis_type,int sub_analysis_type){
+
+	int numdofs=2; //default numdofs
+	int i;
+
+	/*ok, according to analysis type: */
+	if (analysis_type==ControlAnalysisEnum()){
+		numdofs=2;
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+		if (sub_analysis_type==HorizAnalysisEnum()){
+			numdofs=2;
+		}
+		else if (sub_analysis_type==VertAnalysisEnum()){
+			numdofs=1;
+		}
+		else if (sub_analysis_type==StokesAnalysisEnum()){
+			numdofs=4;
+		}
+		else if (sub_analysis_type==HutterAnalysisEnum()){
+			numdofs=2;
+		}
+	}
+	else if (analysis_type==SlopeComputeAnalysisEnum()){
+		numdofs=1;
+	}
+	else if (analysis_type==ThermalAnalysisEnum()){
+		numdofs=1;
+	}
+	else throw ErrorException(__FUNCT__," analysis type not implemented yet!");
+
+	/*Assign output pointers:*/
+	*pnumdofs=numdofs;;
+
+	return 1;
+}
Index: issm/trunk/src/c/shared/Dofs/dofs.h
===================================================================
--- issm/trunk/src/c/shared/Dofs/dofs.h	(revision 464)
+++ issm/trunk/src/c/shared/Dofs/dofs.h	(revision 465)
@@ -7,4 +7,5 @@
 
 double* dofsetgen(int numdofs,int* doflist,int dofspernode,int totaldofs);
+int DistributeNumDofs(int *pnumdofs,int analysis_type,int sub_analysis_type);
 
 
Index: issm/trunk/src/c/shared/Numerics/OptFunc.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/OptFunc.cpp	(revision 464)
+++ issm/trunk/src/c/shared/Numerics/OptFunc.cpp	(revision 465)
@@ -23,5 +23,5 @@
 	double J;
 
-	mxArray*   inputs[8];
+	mxArray*   inputs[9];
 	mxArray*   psearch_scalar=NULL;
 	mxArray*   mxJ=NULL;
@@ -30,5 +30,4 @@
 	psearch_scalar=mxCreateDoubleScalar(scalar);
 	inputs[0]=psearch_scalar;
-	
 	inputs[1]=optargs->m;
 	inputs[2]=optargs->inputs;
@@ -38,6 +37,7 @@
 	inputs[6]=optargs->n;
 	inputs[7]=optargs->analysis_type;
+	inputs[8]=optargs->sub_analysis_type;
 
-	mexCallMATLAB( 1, &mxJ, 8, (mxArray**)inputs, optargs->function_name);
+	mexCallMATLAB( 1, &mxJ, 9, (mxArray**)inputs, optargs->function_name);
 
 	/*extract misfit from mxArray*/
Index: issm/trunk/src/c/shared/Numerics/numerics.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/numerics.h	(revision 464)
+++ issm/trunk/src/c/shared/Numerics/numerics.h	(revision 465)
@@ -15,5 +15,4 @@
 void cross(double* result,double* vector1,double* vector2);
 double norm(double* vector);
-int DistributeNumDofs(int *pnumdofs,int analysis_type);
 
 #endif //ifndef _NUMERICS_H_
Index: issm/trunk/src/m/classes/@model/model.m
===================================================================
--- issm/trunk/src/m/classes/@model/model.m	(revision 464)
+++ issm/trunk/src/m/classes/@model/model.m	(revision 465)
@@ -255,4 +255,5 @@
 	md.solverstring='';
 	md.analysis_type='';
+	md.sub_analysis_type='';
 
 	%management of large models
Index: issm/trunk/src/m/classes/public/BuildQueueingScript.m
===================================================================
--- issm/trunk/src/m/classes/public/BuildQueueingScript.m	(revision 464)
+++ issm/trunk/src/m/classes/public/BuildQueueingScript.m	(revision 465)
@@ -1,7 +1,7 @@
-function BuildQueueingScript(md,solutiontype,executionpath,codepath)
+function BuildQueueingScript(md,executionpath,codepath)
 %BUILDQUEUEINGSCRIPT - 
 %
 %   Usage:
-%      BuildQueueingScript(md,solutiontype,executionpath,codepath)
+%      BuildQueueingScript(md,executionpath,codepath)
 
 disp('building queueing script');
@@ -11,7 +11,7 @@
 if exist(function_name,'file'),
 	%Call this function:
-	eval([function_name '(md,solutiontype,executionpath,codepath);']);
+	eval([function_name '(md,executionpath,codepath);']);
 else
 	%Call the generic BuildQueueingScript:
-	BuildQueueingScriptGeneric(md,solutiontype,executionpath,codepath);
+	BuildQueueingScriptGeneric(md,executionpath,codepath);
 end
Index: issm/trunk/src/m/classes/public/BuildQueueingScriptGeneric.m
===================================================================
--- issm/trunk/src/m/classes/public/BuildQueueingScriptGeneric.m	(revision 464)
+++ issm/trunk/src/m/classes/public/BuildQueueingScriptGeneric.m	(revision 465)
@@ -1,3 +1,3 @@
-function BuildQueueingScriptGeneric(md,solutiontype,executionpath,codepath)
+function BuildQueueingScriptGeneric(md,executionpath,codepath)
 %BUILDQUEUEINGSCRIPTGENERIC - ...
 %
@@ -17,15 +17,14 @@
 fprintf(fid,'mpirun -np %i ',md.np);
 
-if strcmpi(solutiontype,'diagnostic_horiz') |  strcmpi(solutiontype,'diagnostic'),
+if strcmpi(md.analysis_type,'diagnostic'),
 	fprintf(fid,'%s/diagnostic.exe',codepath);
-elseif strcmpi(solutiontype,'control'),
+elseif strcmpi(md.analysis_type,'control'),
 	fprintf(fid,'%s/control.exe',codepath);
-elseif strcmpi(solutiontype,'thermalsteady'),
-	fprintf(fid,'%s/thermalsteady.exe',codepath);
+elseif strcmpi(md.analysis_type,'thermal'),
+	fprintf(fid,'%s/thermal.exe',codepath);
 else
 	error('BuildQueueingScriptGeneric error message: unsupported solution type!');
 end
 
-
 fprintf(fid,' %s %s.bin %s.outbin %s.lock 2> %s.errlog >%s.outlog & ',executionpath,md.name,md.name,md.name,md.name,md.name);
 fclose(fid);
Index: issm/trunk/src/m/classes/public/BuildQueueingScriptcosmos.m
===================================================================
--- issm/trunk/src/m/classes/public/BuildQueueingScriptcosmos.m	(revision 464)
+++ issm/trunk/src/m/classes/public/BuildQueueingScriptcosmos.m	(revision 465)
@@ -2,5 +2,5 @@
 %BUILDQUEUEINGSCRIPTCOSMOS - build queueing script for batch system when running parallel
 %
-%   solutiontype is 'diagnostic','prognostic','transient','thermalsteady','thermaltransient','parameters' or 'control'
+%   solutiontype is 'diagnostic','prognostic','transient','thermal','parameters' or 'control'
 %   and varargin is an optional package name ('cielo', 'ice' or 'macayeal')
 %
@@ -38,12 +38,12 @@
 	fprintf(fid,'mpirun.lsf /home/larour/bin/alloc_cleanup.exe\n');
 end
-if strcmpi(solutiontype,'diagnostic_horiz') |  strcmpi(solutiontype,'diagnostic'),
+if strcmpi(solutiontype,'diagnostic'),
 	fprintf(fid,'mpirun.lsf %s/diagnostic.exe %s %s.bin %s.outbin %s.lock',codepath,executionpath,md.name,md.name,md.name);
 elseif strcmpi(solutiontype,'control') ,
 	fprintf(fid,'mpirun.lsf %s/control.exe %s %s.bin %s.outbin %s.lock',codepath,executionpath,md.name,md.name,md.name);
-elseif strcmpi(solutiontype,'thermalsteady') ,
-	fprintf(fid,'mpirun.lsf %s/thermalsteady.exe %s %s.bin %s.outbin %s.lock',codepath,executionpath,md.name,md.name,md.name);
+elseif strcmpi(solutiontype,'thermal') ,
+	fprintf(fid,'mpirun.lsf %s/thermal.exe %s %s.bin %s.outbin %s.lock',codepath,executionpath,md.name,md.name,md.name);
 else
-	error('BuildQueueingScriptcosmso error message: unsupported solution type!');
+	error('BuildQueueingScriptcosmos error message: unsupported solution type!');
 end
 fclose(fid);
Index: issm/trunk/src/m/classes/public/BuildQueueingScriptgemini.m
===================================================================
--- issm/trunk/src/m/classes/public/BuildQueueingScriptgemini.m	(revision 464)
+++ issm/trunk/src/m/classes/public/BuildQueueingScriptgemini.m	(revision 465)
@@ -22,10 +22,10 @@
 fprintf(fid,'rm -rf %s.outlog %s.errlog %s.lock\n',md.name,md.name,md.name);
 
-if strcmpi(solutiontype,'diagnostic_horiz') |  strcmpi(solutiontype,'diagnostic'),
+if strcmpi(solutiontype,'diagnostic') ,
 	fprintf(fid,'mpirun -np %i %s/diagnostic.exe %s %s.bin %s.outbin %s.lock',md.np,codepath,executionpath,md.name,md.name,md.name);
 elseif strcmpi(solutiontype,'control') ,
 	fprintf(fid,'mpirun -np %i %s/control.exe %s %s.bin %s.outbin %s.lock',md.np,codepath,executionpath,md.name,md.name,md.name);
-elseif strcmpi(solutiontype,'thermalsteady') ,
-	fprintf(fid,'mpirun -np %i %s/thermalsteady.exe %s %s.bin %s.outbin %s.lock',md.np,codepath,executionpath,md.name,md.name,md.name);
+elseif strcmpi(solutiontype,'thermal') ,
+	fprintf(fid,'mpirun -np %i %s/thermal.exe %s %s.bin %s.outbin %s.lock',md.np,codepath,executionpath,md.name,md.name,md.name);
 else
 	error('BuildQueueingScriptgemini error message: unsupported solution type!');
Index: issm/trunk/src/m/classes/public/ismodelselfconsistent.m
===================================================================
--- issm/trunk/src/m/classes/public/ismodelselfconsistent.m	(revision 464)
+++ issm/trunk/src/m/classes/public/ismodelselfconsistent.m	(revision 465)
@@ -1,11 +1,11 @@
-function bool=ismodelselfconsistent(md,solutiontype,package),
+function bool=ismodelselfconsistent(md,package),
 %ISMODELSELFCONSISTENT - check that model forms a closed form solvable problem.
 %
 %   Usage:
-%      bool=ismodelselfconsistent(md,solutiontype,package),
+%      bool=ismodelselfconsistent(md,package),
 
 %tolerance we use in litmus tests for the consistency of the model
 tolerance=10^-12;
-if (nargin~=3  )
+if (nargin~=2  )
 	help ismodelselfconsistent
 	error('ismodelselfconsistent error message: wrong usage');
@@ -115,5 +115,5 @@
 
 %SIZE NUMBEROFGRIDS
-fields={'x','y','z','B','drag','gridondirichlet_diag','melting','accumulation','surface','thickness','bed','gridonbed','gridonsurface','deadgrids'};
+fields={'x','y','z','B','drag','gridondirichlet_diag','melting','accumulation','surface','thickness','bed','gridonbed','gridonsurface'};
 for i=1:length(fields),
 	if find(length(eval(['md.' char(fields(i))]))~=md.numberofgrids),
@@ -159,5 +159,5 @@
 
 %DIAGNOSTIC
-if strcmpi(solutiontype,'diagnostic')
+if strcmpi(md.analysis_type,'diagnostic')
 
 	%HUTTER ON ICESHELF WARNING
@@ -189,5 +189,5 @@
 
 %PROGNOSTIC
-if strcmp(solutiontype,'prognostic'),
+if strcmp(md.analysis_type,'prognostic'),
 	%old testing
 	%	if isempty(find(md.gridondirichlet_diag)),
@@ -208,23 +208,25 @@
 
 %THERMAL TRANSIENT
-if strcmp(solutiontype,'thermaltransient')
-
-	%INITIAL TEMPERATURE, MELTING AND ACCUMULATION
-	if isempty(md.temperature),
-		disp(['An  initial temperature is needed for a transient thermal computation'])
-		bool=0;return;
-	end
-	if isstruct(md.temperature) |  isstruct(md.melting) | isstruct(md.accumulation),
-		disp(['The initial temperature, melting or accumulation should be a list and not a structure'])
-		bool=0;return;
+if strcmp(md.analysis_type,'thermal')
+	if strcmp(md.sub_analysis_type,'transient')
+
+		%INITIAL TEMPERATURE, MELTING AND ACCUMULATION
+		if isempty(md.temperature),
+			disp(['An  initial temperature is needed for a transient thermal computation'])
+			bool=0;return;
+		end
+		if isstruct(md.temperature) |  isstruct(md.melting) | isstruct(md.accumulation),
+			disp(['The initial temperature, melting or accumulation should be a list and not a structure'])
+			bool=0;return;
+		end
 	end
 end
 
 %THERMAL STEADY AND THERMAL TRANSIENT
-if strcmpi(solutiontype,'thermalsteady') |  strcmp(solutiontype,'thermaltransient'),
+if strcmpi(md.analysis_type,'thermal'),
 
 	%EXTRUSION
 	if strcmp(md.type,'2d'),
-		disp(['For a ' solutiontype ' computation, the model must be 3d, extrude it first!'])
+		disp(['For a ' md.analysis_type ' computation, the model must be 3d, extrude it first!'])
 		bool=0;return;
 	end
@@ -242,5 +244,5 @@
 
 %THERMAL TRANSIENT AND TRANSIENT
-if strcmp(solutiontype,'thermaltransient') | strcmp(solutiontype,'transient'),
+if strcmp(md.analysis_type,'thermal'),
 
 	%DT and NDT
@@ -261,5 +263,5 @@
 
 %PARAMETERS
-if strcmp(solutiontype,'parameters')
+if strcmp(md.analysis_type,'parameters')
 
 	%OUTPUT
@@ -289,5 +291,5 @@
 
 %CONTROL
-if strcmpi(solutiontype,'control'),
+if strcmpi(md.analysis_type,'control'),
 
 	%CONTROL TYPE
@@ -320,5 +322,5 @@
 
 %QMU
-if strcmpi(solutiontype,'qmu'),
+if strcmpi(md.analysis_type,'qmu'),
 	if ~strcmpi(md.cluster,'none'),
 		if md.waitonlock==0,
@@ -330,5 +332,5 @@
 
 %MESH
-if strcmpi(solutiontype,'mesh'),
+if strcmpi(md.analysis_type,'mesh'),
 	%this solution is a little special. It should come right after the md=model;  operation. So a lot less checks!
 
@@ -338,5 +340,5 @@
 
 %MESH2GRID
-if strcmpi(solutiontype,'mesh2grid'),
+if strcmpi(md.analysis_type,'mesh2grid'),
 	if ~strcmpi(md.cluster,'none'),
 		disp(['model is not correctly configured: mesh2grid not supported in parallel yet!']);
Index: issm/trunk/src/m/classes/public/isresultconsistent.m
===================================================================
--- issm/trunk/src/m/classes/public/isresultconsistent.m	(revision 464)
+++ issm/trunk/src/m/classes/public/isresultconsistent.m	(revision 465)
@@ -1,3 +1,3 @@
-function bool=isresultconsistent(md,solutiontype),
+function bool=isresultconsistent(md)
 %ISRESULTCONSISTENT: check that results are consistent
 %
@@ -6,15 +6,15 @@
 %
 %   Usage:
-%      bool=IsModelSelfConsistent(model,solutiontype)
+%      bool=IsModelSelfConsistent(model)
 
 %tolerance we use in litmus tests for the consistency of the model
 tolerance=10^-2;
 
-if (nargin~=2  )
+if (nargin~=1  )
 	IsResultConsistentUsage();
 	error(' ');
 end
 %Check velocities i(no penalties for 2d meshes)
-if (strcmp(solutiontype,'diagnostic') || strcmp(solutiontype,'diagnostic_horiz') ),
+if strcmp(md.analysis_type,'diagnostic'),
 
 	if strcmpi(md.type,'3d'),
@@ -37,9 +37,9 @@
 end
 
-if strcmp(solutiontype,'thermalsteady')
+if strcmp(md.analysis_type,'thermal')
 
 	%check melting 
 	if any(abs(md.melting(md.numberofgrids2d+1:end))>tolerance)
-		disp(['''thermalsteady'' result not consistent: increase penalty_melting (negative melting)']);
+		disp(['''thermal'' result not consistent: increase penalty_melting (negative melting)']);
 		bool=0; return; 
 	end
@@ -47,5 +47,5 @@
 end
 
-if strcmp(solutiontype,'thermaltransient')
+if strcmp(md.analysis_type,'thermaltransient')
 
 	for iter=1:length(md.thermaltransient_results)
@@ -61,5 +61,5 @@
 
 
-if (strcmp(solutiontype,'transient') & strcmpi(md.type,'3d')),
+if (strcmp(md.analysis_type,'transient') & strcmpi(md.type,'3d')),
 	for iter=1:length(md.transient_results)
 
@@ -99,4 +99,4 @@
 function IsResultConsistentUsage()
 disp(' ');
-disp('   IsResultConsistent usage: flag=IsResultConsistent(model,solutiontype)');
+disp('   IsResultConsistent usage: flag=IsResultConsistent(model)');
 disp('         where model is an instance of the @model class, and flag a boolean');
Index: issm/trunk/src/m/classes/public/loadresultsfromcluster.m
===================================================================
--- issm/trunk/src/m/classes/public/loadresultsfromcluster.m	(revision 464)
+++ issm/trunk/src/m/classes/public/loadresultsfromcluster.m	(revision 465)
@@ -1,7 +1,7 @@
-function md=loadresultsfromcluster(md,solutiontype)
+function md=loadresultsfromcluster(md)
 %LOADRESULTSFROMCLUSTER - load results of solution sequence from cluster
 %
 %   Usage:
-%      md=loadresultsfromcluster(md,solutiontype);
+%      md=loadresultsfromcluster(md);
 
 %Get cluster.rc location
@@ -31,5 +31,5 @@
 
 %If we are here, no errors in the solution sequence, call loadresultsfromdisk.
-md=loadresultsfromdisk(md,[md.name '.outbin'],solutiontype);
+md=loadresultsfromdisk(md,[md.name '.outbin'],md.analysis_type);
 
 %erase the log and output files
Index: issm/trunk/src/m/classes/public/loadresultsfromdisk.m
===================================================================
--- issm/trunk/src/m/classes/public/loadresultsfromdisk.m	(revision 464)
+++ issm/trunk/src/m/classes/public/loadresultsfromdisk.m	(revision 465)
@@ -1,3 +1,3 @@
-function md=loadresultsfromdisk(md,filename,solutiontype)
+function md=loadresultsfromdisk(md,filename)
 %LOADRESULTSFROMDISK - load results of solution sequence from disk file "filename"            
 %
@@ -103,5 +103,5 @@
 disp(sprintf('%s\n','checking result consistency'));
 
-if ~isresultconsistent(md,solutiontype),
+if ~isresultconsistent(md),
 	disp('!! results not consistent correct the model !!') %it would be very cruel to put an error, it would kill the computed results (even if not consistent...)
 end
Index: issm/trunk/src/m/classes/public/marshall.m
===================================================================
--- issm/trunk/src/m/classes/public/marshall.m	(revision 464)
+++ issm/trunk/src/m/classes/public/marshall.m	(revision 465)
@@ -1,11 +1,10 @@
-function marshall(md,solutiontype,package)
+function marshall(md)
 %MARSHALL - output Cielo compatible binary file from @model md, for certain solution type.
 %
 %   The routine creates a Cielo compatible binary file from @model md
-%   solutiontype can be 'diagnostic','prognostic' or 'control'. 
 %   This binary file will be used for parallel runs in cielo.
 %
 %   Usage:
-%      marshall(md,solutiontype,package)
+%      marshall(md)
 
 %some checks on list of arguments
@@ -23,9 +22,6 @@
 end
 
-if strcmp(solutiontype,'diagnostic'),
-	WriteData(fid,'diagnostic_horiz','String','analysis_type');
-else
-	WriteData(fid,solutiontype,'String','analysis_type');
-end
+WriteData(fid,md.analysis_type','String','analysis_type');
+WriteData(fid,md.sub_analysis_type','String','sub_analysis_type');
 WriteData(fid,md.type,'String','type');
 WriteData(fid,md.numberofgrids,'Integer','numberofgrids');
